/*
 * GPS.c
 *
 * Created: 25.01.2021 11:32:26
 * Author:  R0AEK
 * Ver		1.05
 */

#include "GPS.h"

/*---------------------------------------------------------------------------------*/
char slat[12]					= "";		//      (N 5506.5230)
char slon[12]					= "";		//     (E 08256.8760)
char chLat						= 'N';		//   N/S
char chLon						= 'E';		//  E/W
char GPSData[100]				= "";		// GPS 

uint8_t Separator				= 0;		//   GPS 
uint8_t GPSDataStringReceived	= 0;		//     GPS
uint8_t FixStr					= 0;		//    GPS 
int GPSDataIndex				= 0;		//    GPS 
int GPSDataIdx					= 0;		//--

extern uint8_t TimeModule;					//  
extern uint8_t TransmitDelay;				//     
extern uint8_t PrevTimeStartTX;				//     
extern uint8_t DisplayModule;				//    1602 0-LED's 1-i2c led_on 2-i2c led_off
extern uint8_t FirstTX;
extern uint8_t LED_Status_Blink;

extern uint8_t flagConnectToPC;
uint8_t gps_Data[64];

/*END -----------------------------------------------------------------------------*/

/* GPS   QTH */
void GPSCoorToQTHLoc()
{
	/* //  */
	//char slat_1[6];
	//char slat_deg[4];
	//char slat_min[4];
	//char slat_2[6];
	//char slat_sec[4];
	//int32_t lat_deg;
	//int32_t lat_min;
	//int32_t lat_sec;
	
	/* //  */
	//char slon_1[6];
	//char slon_deg[5];
	//char slon_min[4];
	//char slon_2[6];
	//char slon_sec[4];
	//int32_t lon_deg;
	//int32_t lon_min;
	//int32_t lon_sec;
	
	/* */
	//int32_t dec_lat;
	//int32_t dec_lon;
	
	/* QTH */
	//char qth_loc[6];
	//int i = 0;
	
	//   //
	/*--------------------------------------------*/
	//    , 4 
	//while (slat[i] != '.')
	//{
		//slat_1[i] = slat[i];
		//i++;
	//}
	//    , 4 
	//for (int y=0;y<4;y++)
	//{
		//i++;
		//slat_2[y] = slat[i];
	//}
	//    
	//i = 0;
	//while (i<2)
	//{
		//slat_deg[i] = slat_1[i];
		//i++;
	//}
	//    
	//lat_deg = atoi(slat_deg);
	//itoa(lat_deg,slat_deg,10);
	//    
	//while (i<4)
	//{
		//slat_min[i-2] = slat_1[i];
		//i++;
	//}
	//    
	//lat_min = atoi(slat_min);
	//itoa(lat_min,slat_min,10);
	/*   - (ZZZZ * 60 / 10000)
	    * 60 / 10000
	*/
	//lat_sec = atoi(slat_2);
	//lat_sec = (int32_t)(lat_sec*60/10000l);
	//itoa(lat_sec,slat_sec,10);
	/*END ----------------------------------------*/
		
	/*-------------------------------------------*/
	//    , 5 
	//i = 0;
	//while (slon[i] != '.')
	//{
		//slon_1[i] = slon[i];
		//i++;
	//}
	
	//    , 4 
	//for (int y=0;y<4;y++)
	//{
		//i++;
		//slon_2[y] = slon[i];
	//}
	//    
	//i = 0;
	//while (i<3)
	//{
		//slon_deg[i] = slon_1[i];
		//i++;
	//}
	//    
	//lon_deg = atoi(slon_deg);
	//itoa(lon_deg,slon_deg,10);
	//    
	//while (i<4)
	//{
		//slon_min[i-2] = slon_1[i];
		//i++;
	//}
	//    
	//lon_min = atoi(slon_min);
	//itoa(lon_min,slon_min,10);
	/*   - (ZZZZ * 60 / 10000)
	    * 60 / 10000
	*/
	//lon_sec = atoi(slon_2);
	//lon_sec = (int32_t)(lon_sec*60/10000l);
	//itoa(lon_sec,slon_sec,10);
	/*END ---------------------------------------*/
		
	/*!!!!!!    -------*/
	//LCD_set_pos(0,0);
	//LCD_send_str(slat_deg);
	//LCD_send_char(223); //
	//LCD_send_str(slat_min);
	//LCD_send_char(39); //
	//LCD_send_str(slat_sec);
	//LCD_send_char(34); //
	
	//LCD_set_pos(0,1);
	//LCD_send_str(slon_deg);
	//LCD_send_char(223); //
	//LCD_send_str(slon_min);
	//LCD_send_char(39); //
	//LCD_send_str(slon_sec);
	//LCD_send_char(34); //
	/*END !!!!!!    ---*/
	
	/* QTH-------------------------------------------------------*/
	//    ??????????????????
	//dec_lat = lat_deg; //(int32_t)(lat_deg+(lat_min/60)+(lat_sec/60));
	//dec_lon = lon_deg; //(int32_t)(lon_deg+(lon_min/60)+(lon_sec/60));
	//
	//if (chLat == 'S') dec_lat *= -1;
	//if (chLon == 'W') dec_lon *= -1;
	//
	////  QTH 
	//dec_lat += 90;								// 
	//dec_lon += 180;								// 
	//
	//int32_t y = floor(dec_lon / 20);
	//qth_loc[0] = QTHLocPrefix[y];				//1- : 20  
	//
	//y = floor(dec_lat / 10);
	//qth_loc[1] = QTHLocPrefix[y];				//2- : 10  
//
	//y = floor((dec_lon % 20) / 2);
	//qth_loc[2] = QTHLocNumber[y];				//3- : 2  
//
	//y = floor((dec_lat % 10) / 1);
	//qth_loc[3] = QTHLocNumber[y];				//4- : 1  
	
 	//y = floor((dec_lon % 2) * (60 / 5));
 	//qth_loc[4] = QTHLocSuffix[y];				//5- : 5   
 //
 	//y = floor((dec_lat % 1) * (60 / 2.5));
 	//qth_loc[5] = QTHLocSuffix[y];				//6- : 2.5   
	
	/*   5  6  QTH  !!!!!!!!!!!!!!!!!!!!!!
	     1-2-3-4 
	*/
	
	//  QTH   
	//LCD_set_pos(12,1);
	//for (int i=0;i<4;i++)
	//{
		//LCD_send_char(qth_loc[i]);
	//}
	/*END  QTH---------------------------------------------------*/
}

/*  GPS */
void Parsing_GPS_Message()
{	
	// : $GPGGA,153145.00,5501.8492,N,08255.0987,E,1,08,2.0,150,M,0,M,,,*31
	/*0     
	1        .
	2     .
	3   // (N/S).
	4     .
	5   // (E/W).
	6     GPS :
		 0          ;
		 1    GPS   ,   ;
		 2     GPS ,  ,   ;
		 3/6  GPS   ,   .
	7      (00...12,     ).
	8        ((HDOP).
	9        .
	10      , .
	11         WGS 84    (),      .
	12    , .
	13     GPS         SC104  1  9,  ,     .
	14   ,   , ID, 0000 1023.      ,    ,
		       BoB (Beacon on a Belt)    .
	15    .*/
	
	/*   SoftUART*/
	SUART_TurnRxOff();
	GPSDataStringReceived = 0;
	
	int i = 0;
	int y = 0;
	
	//    hh:mm:ss
	{
		if (flagConnectToPC == 0)
			//   
			LCD_set_pos(8,0);
		else
		{
			//   UART
			gps_Data[0] = 'I';
			gps_Data[1] = '3';
			gps_Data[2] = ',';
		}
		
		for (i=7;i<13;i++)
		{
			if (GPSData[i] != ',')
			{
				if ((i == 9)||(i == 11))
				{
					if (flagConnectToPC == 0)
						//  ":"   
						LCD_send_char(':');
				}
				if (flagConnectToPC == 0)
					//     
					LCD_send_char(GPSData[i]);
				else
					//   UART
					gps_Data[i-4] = GPSData[i];
			}
		}

		if (flagConnectToPC == 1)
			//  ,   ","  
			gps_Data[i-4] = ',';	
	}
	
	// lat -   N/S
	{
		if (flagConnectToPC == 1)
		{
			y = 0;
			
			//     
			for (i=0;y!=2;i++)
			{
				if (GPSData[i] == ',') y++;
			}
			
			//     ','
			while (GPSData[i] != ',')
			{
				gps_Data[i-7] = GPSData[i];
				i++;
			}
			gps_Data[i-7] = ',';
			i++;
			gps_Data[i-7] = GPSData[i];
			i++;
			gps_Data[i-7] = GPSData[i];
		}
	}
	
	// lon -   E/W
	{
		if (flagConnectToPC == 1)
		{
			y = 0;
			
			//     
			for (i=0;y!=4;i++)
			{
				if (GPSData[i] == ',') y++;
			}
			
			//     ','
			while (GPSData[i] != ',')
			{
				gps_Data[i-7] = GPSData[i];
				i++;
			}
			gps_Data[i-7] = ',';
			i++;
			gps_Data[i-7] = GPSData[i];
			i++;
			gps_Data[i-7] = GPSData[i];
		}
	}
	
	// Position Fix Status Indicator
	{
		if (flagConnectToPC == 0)
			LCD_set_pos(15,1);
		
		y = 0;
		
		//     
		for (i=0;y!=6;i++)
		{
			if (GPSData[i] == ',') y++;
		}
		
		//     ','
		while (GPSData[i] != ',')
		{
			if (flagConnectToPC == 0)
				LCD_send_char(GPSData[i]);
			else
				gps_Data[i-7] = GPSData[i];
			i++;
		}
		gps_Data[i-7] = ',';
	}
	
	// Satellites Used
	{
		if (flagConnectToPC == 0)
			LCD_set_pos(10,1);
		
		y = 0;
		
		//     
		for (i=0;y!=7;i++)
		{
			if (GPSData[i] == ',') y++;
		}
		
		//     ','
		while (GPSData[i] != ',')
		{
			if (flagConnectToPC == 0)
				LCD_send_char(GPSData[i]);
			else
				gps_Data[i-7] = GPSData[i];
			i++;
		}
		gps_Data[i-7] = ',';
	}
	
	// HDOP, Horizontal Dilution of Precision/MSL Altitude; Units/Meters (fixed field)/Geoid Separation/Meters (fixed field)
	{
		if (flagConnectToPC == 1)
		{
			y = 0;
			
			//     
			for (i=0;y!=8;i++)
			{
				if (GPSData[i] == ',') y++;
			}
			
			//     ','
			while (y != 14)
			{
				if (GPSData[i] == ',') y++;
				
				gps_Data[i-7] = GPSData[i];
				i++;
			}
			gps_Data[i-7] = ',';
		}
	}
	
	/*--------------------------------------------------------------------------------*/
	
	//  GPS  1/2/3      QTH-
	{
		/*if (flagConnectToPC == 0)
		{
			if ((GPSData[y] == '1')||(GPSData[y] == '2')||(GPSData[y] == '3')||(GPSData[y] == '6'))
			{
				////lat -   N/S
				////LCD_set_pos(0,1);
				//y = 0;
				//for (int i=0;y<8;i++)
				//{
					//if (GPSData[i] == ',') y++;
					//if (y == 2) y = i+1;
				//}
				////  
				//int z = 0;
				//while (GPSData[y] != ',')
				//{
					////LCD_send_char(GPSData[y]);
					//slat[z] = GPSData[y];
					//z++;
					//
					//if (flagConnectToPC == 1)
					//{
						//i++;
						//gps_Data[i-5] = GPSData[y];
					//}
					//
					//y++;
				//}
				////LCD_send_char(' ');
				//if (flagConnectToPC == 1)
				//{
					//i++;
					//gps_Data[i-5] = ',';
					//i++;
					//gps_Data[i-5] = GPSData[y+1];
					//i++;
					//gps_Data[i-5] = ',';
				//}
				//
				//chLat = GPSData[y+1];
				//LCD_send_char(GPSData[y+1]);
				
				/ * ---------* /
				//LCD_set_pos(0,0);
				//LCD_send_char(chLat);
				//LCD_send_char(' ');
				//LCD_send_str(slat);
				/ *END   ----* /
				
				////lon -   E/W
				////LCD_set_pos(0,1);
				//y = 0;
				//for (int i=0;y<8;i++)
				//{
					//if (GPSData[i] == ',') y++;
					//if (y == 4) y = i+1;
				//}
				////  
				//z = 0;
				//while (GPSData[y] != ',')
				//{
					////LCD_send_char(GPSData[y]);
					//slon[z] = GPSData[y];
					//z++;
					//
					//if (flagConnectToPC == 1)
					//{
						//i++;
						//gps_Data[i-5] = GPSData[y];
					//}
					//
					//y++;
				//}
				////LCD_send_char(' ');
				//if (flagConnectToPC == 1)
				//{
					//i++;
					//gps_Data[i-5] = ',';
					//i++;
					//gps_Data[i-5] = GPSData[y+1];
					//i++;
					//gps_Data[i-5] = ',';
				//}
				//
				//chLon = GPSData[y+1];
				//LCD_send_char(GPSData[y+1]);
				
				/ * ---------* /
				//LCD_set_pos(0,1);
				//LCD_send_char(chLon);
				//LCD_send_char(' ');
				//LCD_send_str(slon);
				/ *END   ----* /
				
				/ *     QTH * /
				//GPSCoorToQTHLoc();
			}
		}*/
	}
	
	/*--------------------------------------------------------------------------------*/
	
	//   OLED     
	{
		if ((flagConnectToPC == 0)&&((DisplayModule == 5)||(DisplayModule == 6)))
		{
			char tmpStr[10];
			
			//   
			if (GPSData[12] == '5')
				PlotText(PSTR("  Waiting  "), 0, 0);
			
			if (GPSData[12] == '0')
				PlotText(PSTR("    GPS    "), 0, 0);
			
			//      OLED 
			if (GPSData[7] == ',')
				sprintf(tmpStr, " no  data ");
			else
				sprintf(tmpStr, " %c%c:%c%c:%c%c ", GPSData[7], GPSData[8], GPSData[9], GPSData[10], GPSData[11], GPSData[12]);
			
			int y = 0;
			for (int i=0;i<10;i++)
			{
				PlotChar(tmpStr[i],2,y);
				y += 13;
			}
		}
	}
	
	/*   WSPR */
	{
		if (flagConnectToPC == 0)
		{
			if(((GPSData[10] == '0')||(GPSData[10] == '2')||(GPSData[10] == '4')||(GPSData[10] == '6')||(GPSData[10] == '8'))&&(GPSData[11] == '0')&&(GPSData[12] == '1'))
			{
				if ((TransmitDelay != '0')&&(FirstTX == 0))
				{	//      
					//  
					PrevTimeStartTX++;
					
					switch (TransmitDelay)
					{
						case '1':  if(PrevTimeStartTX == 2) {PrevTimeStartTX = 0; Transmit_WSPR();};	//  
						break;
						case '2':  if(PrevTimeStartTX == 3) {PrevTimeStartTX = 0; Transmit_WSPR();};	//  
						break;
						case '3':  if(PrevTimeStartTX == 4) {PrevTimeStartTX = 0; Transmit_WSPR();};	//  
						break;
						case '4':  if(PrevTimeStartTX == 5) {PrevTimeStartTX = 0; Transmit_WSPR();};	//  
						break;
						
						default: ;
					}
				}
				else
				{
					if (FirstTX == 1)
					{
						//   
						FirstTX = 0;
					}
					// 
					Transmit_WSPR();
				}
				//_delay_ms(1000);
			}
		}
	}
	
	if (flagConnectToPC == 0)
		/*   SoftUART*/
		SUART_TurnRxOn();
}

/*  GPS */
void Receive_GPS_Data(char ch)
{
	GPSData[GPSDataIndex] = ch;
	GPSDataIndex++;
	
	//  $GPGGA
	if(GPSDataIndex < 7)
	{
		/* GPS  NEO-6x*/
		if(GPSData[GPSDataIndex - 1] != GPGGA[GPSDataIndex - 1])
		{
			GPSDataIndex = 0;
			FixStr = 0;
		}
		else
			if (GPSDataIndex == 6)
				FixStr = 1;	
	}
	else
	{
		//  ()
		if (ch == ',')
			Separator++;
		
		//    
		if /*(*/(Separator >= 14)/*&&(FixStr == 1))*/
		{
			if (FixStr == 1)
			{
				//  
				GPSDataStringReceived = 1;
				FixStr = 0;
			}
			Separator = 0;
			GPSDataIndex = 0;
			
			// GPS   PC
			if (flagConnectToPC == 1)
				GPStoPC();
		}	
	}
}


