/*
 * Lcd_1602.h
 *
 * Created: 29.03.2020 23:17:18
 * Author: R0AEK
 * Ver - 1.05
 */ 

#ifndef LCD_1602_H_
#define LCD_1602_H_

#include "Main.h"

//  LCD1602  i2c (  i2c   PCF8574 = 0x4E)
#define e1			I2C_SendByteByADDR(portlcd |=  0x04,i2c_1602)	//  E  1
#define e0			I2C_SendByteByADDR(portlcd &= ~0x04,i2c_1602)	//  E  0
#define rs1			I2C_SendByteByADDR(portlcd |=  0x01,i2c_1602)	//  RS  1 ()
#define rs0			I2C_SendByteByADDR(portlcd &= ~0x01,i2c_1602)	//  RS  0 ()
#define ledOn()		I2C_SendByteByADDR(portlcd |=  0x08,i2c_1602)	// 
#define ledOff()	I2C_SendByteByADDR(portlcd &= ~0x08,i2c_1602)	// 
#define setWrite()	I2C_SendByteByADDR(portlcd &= ~0x02,i2c_1602)	//   
 
//
void LCD_send_half_byte (unsigned char c);
void LCD_send_byte (unsigned char c, unsigned char mode);
void LCD_send_char (unsigned char c);
void LCD_send_str (char str[]);
void LCD_set_pos (unsigned char x, unsigned y);
void LCD_ini (void);

#endif /* LCD_1602_H_ */