/*
 * OLED.
 * 128x32/128x64
 *
 * Created: 04.01.2022 15:12
 * Author:	David Johnson-Davies - www.technoblogy.com - 21st October 2020
 *			Smooth Big Text - see http://www.technoblogy.com/show?3AJ7
 *			CC BY 4.0
 *			Licensed under a Creative Commons Attribution 4.0 International license:
 *			http://creativecommons.org/licenses/by/4.0/
 * Mod:		R0AEK
 * Ver:		1.05
 */  

#ifndef OLED_096_H_
#define OLED_096_H_

#include "Main.h"

void PlotChar(int c, int line, int column);
void PlotText(PGM_P s, int line, int column);
void OLED_init(void);
void OLED_clear(void);
void OLED_write(uint8_t mode, uint8_t data);

#endif /* OLED_096_H_ */